#include "test_objects.h"
#include "test_resources.h"

//--------------------- User code ---------------------//

// Ir Termo click constants
const _IR_THERMO_ADDR = 0x5A;
const _AMB_TEMP       = 0x06;
const _OBJ_TEMP       = 0x07;
const _FAHRENHEIT     = 0x01;
const _CELSIUS        = 0x02;
// Globals
float Temp;
char temp_format;
char counter;

void init_kul() {
  temp_format = _CELSIUS;
  counter = 200;
}

float ReadSensor(unsigned char Temp_Source){
  unsigned char Temp_var[2] = {0};
  unsigned char _data[2];
//_data[1] = _IR_THERMO_ADDR;
  _data[0] =  Temp_Source;

  I2C2_Start();              // issue I2C start signal
  I2C2_Write(_IR_THERMO_ADDR, _data, 1, END_MODE_RESTART);
  I2C2_Read(_IR_THERMO_ADDR, Temp_var, 2, END_MODE_STOP);
  return (float)((Temp_var[1] << 8) + Temp_var[0]);
}


float Read_Temperature(char Source){
float Temperatue;

  Temperatue = ReadSensor(Source);          // Read Ambient temperature
  if (temp_format == _FAHRENHEIT)
    Temperatue = ((Temperatue * 0.02) - 273.15) * 9.0/5 + 32; // Convert result in FAHRENHEIT degrees
  else if (temp_format == _CELSIUS)
    Temperatue = (Temperatue * 0.02) - 273.15;       // Convert result in Celsius degrees
  else
    Temperatue = 0;

  return Temperatue;
}

void Display_Temperature(char Temp_Source, float temperature){
  char text[40];

  FloatToStr(temperature, text); // Convert temperature into string
  if (text[1] == '.')            // display it with only two decimals
    text[4] = 0;
  if (text[2] == '.')
    text[5] = 0;
  if (text[3] == '.')
    text[6] = 0;
  if (text[4] == '.')
    text[7] = 0;
    TFT_Set_Font(Lucida_Console_KOI815x25_Bold, CL_WHITE, FO_HORIZONTAL);
    TFT_Set_Pen(CL_BLACK, 20);
    TFT_Write_Text("\xEF\xCB\xD2\xD5\xD6\xC5\xCE\xC9\xC5", 10, 50);
    TFT_Write_Text("\xEF\xC2\xDF\xC5\xCB\xD4", 10, 80);

  if (Temp_Source == _AMB_TEMP){  // Display result
    TFT_Line(168, 60, 260, 60);
    TFT_Write_Text(text, 170, 50);

  }
  if (Temp_Source == _OBJ_TEMP){
    TFT_Line(168, 90, 260, 90);
    TFT_Write_Text(text, 170, 80);
  }
}

void run_start() {
    if (counter > 150){
      Temp = Read_Temperature(_AMB_TEMP);
      Display_Temperature(_AMB_TEMP, Temp);  // Display result

      Temp = Read_Temperature(_OBJ_TEMP);    // Read Ambient temperature
      Display_Temperature(_OBJ_TEMP, Temp);  // Display result

      counter = 0;
    }
    else
      counter ++;

    Delay_ms(2);
}

//----------------- End of User code ------------------//

// Event Handlers